# _SignedPartialArithmetic
<span class="source-link">[[Source]](src/builtin/_partial_arithmetic.md#L44)</span>
```pony
primitive val _SignedPartialArithmetic is
  _PartialArithmetic ref
```

#### Implements

* [_PartialArithmetic](builtin-_PartialArithmetic) ref

---

## Constructors

### create
<span class="source-link">[[Source]](src/builtin/_partial_arithmetic.md#L44)</span>


```pony
new val create()
: _SignedPartialArithmetic val^
```

#### Returns

* [_SignedPartialArithmetic](builtin-_SignedPartialArithmetic) val^

---

## Public Functions

### div_checked\[T: ([_SignedInteger](builtin-_SignedInteger)\[T, U\] val & ([I8](builtin-I8) val | [I16](builtin-I16) val | [I32](builtin-I32) val | [I64](builtin-I64) val | [I128](builtin-I128) val | [ILong](builtin-ILong) val | [ISize](builtin-ISize) val)), U: [_UnsignedInteger](builtin-_UnsignedInteger)\[U\] val\]
<span class="source-link">[[Source]](src/builtin/_partial_arithmetic.md#L46)</span>


```pony
fun box div_checked[T: (_SignedInteger[T, U] val & (I8 val | I16 val | I32 val | 
    I64 val | I128 val | ILong val | 
    ISize val)), U: _UnsignedInteger[U] val](
  x: T,
  y: T)
: (T , Bool val)
```
#### Parameters

*   x: T
*   y: T

#### Returns

* (T , [Bool](builtin-Bool) val)

---

### rem_checked\[T: ([_SignedInteger](builtin-_SignedInteger)\[T, U\] val & ([I8](builtin-I8) val | [I16](builtin-I16) val | [I32](builtin-I32) val | [I64](builtin-I64) val | [I128](builtin-I128) val | [ILong](builtin-ILong) val | [ISize](builtin-ISize) val)), U: [_UnsignedInteger](builtin-_UnsignedInteger)\[U\] val\]
<span class="source-link">[[Source]](src/builtin/_partial_arithmetic.md#L49)</span>


```pony
fun box rem_checked[T: (_SignedInteger[T, U] val & (I8 val | I16 val | I32 val | 
    I64 val | I128 val | ILong val | 
    ISize val)), U: _UnsignedInteger[U] val](
  x: T,
  y: T)
: (T , Bool val)
```
#### Parameters

*   x: T
*   y: T

#### Returns

* (T , [Bool](builtin-Bool) val)

---

### div_partial\[T: ([_SignedInteger](builtin-_SignedInteger)\[T, U\] val & ([I8](builtin-I8) val | [I16](builtin-I16) val | [I32](builtin-I32) val | [I64](builtin-I64) val | [I128](builtin-I128) val | [ILong](builtin-ILong) val | [ISize](builtin-ISize) val)), U: [_UnsignedInteger](builtin-_UnsignedInteger)\[U\] val\]
<span class="source-link">[[Source]](src/builtin/_partial_arithmetic.md#L52)</span>


```pony
fun box div_partial[T: (_SignedInteger[T, U] val & (I8 val | I16 val | I32 val | 
    I64 val | I128 val | ILong val | 
    ISize val)), U: _UnsignedInteger[U] val](
  x: T,
  y: T)
: T ?
```
#### Parameters

*   x: T
*   y: T

#### Returns

* T ?

---

### rem_partial\[T: ([_SignedInteger](builtin-_SignedInteger)\[T, U\] val & ([I8](builtin-I8) val | [I16](builtin-I16) val | [I32](builtin-I32) val | [I64](builtin-I64) val | [I128](builtin-I128) val | [ILong](builtin-ILong) val | [ISize](builtin-ISize) val)), U: [_UnsignedInteger](builtin-_UnsignedInteger)\[U\] val\]
<span class="source-link">[[Source]](src/builtin/_partial_arithmetic.md#L59)</span>


```pony
fun box rem_partial[T: (_SignedInteger[T, U] val & (I8 val | I16 val | I32 val | 
    I64 val | I128 val | ILong val | 
    ISize val)), U: _UnsignedInteger[U] val](
  x: T,
  y: T)
: T ?
```
#### Parameters

*   x: T
*   y: T

#### Returns

* T ?

---

### divrem_partial\[T: ([_SignedInteger](builtin-_SignedInteger)\[T, U\] val & ([I8](builtin-I8) val | [I16](builtin-I16) val | [I32](builtin-I32) val | [I64](builtin-I64) val | [I128](builtin-I128) val | [ILong](builtin-ILong) val | [ISize](builtin-ISize) val)), U: [_UnsignedInteger](builtin-_UnsignedInteger)\[U\] val\]
<span class="source-link">[[Source]](src/builtin/_partial_arithmetic.md#L66)</span>


```pony
fun box divrem_partial[T: (_SignedInteger[T, U] val & (I8 val | I16 val | I32 val | 
    I64 val | I128 val | ILong val | 
    ISize val)), U: _UnsignedInteger[U] val](
  x: T,
  y: T)
: (T , T) ?
```
#### Parameters

*   x: T
*   y: T

#### Returns

* (T , T) ?

---

### neg_partial\[T: ([_SignedInteger](builtin-_SignedInteger)\[T, U\] val & ([I8](builtin-I8) val | [I16](builtin-I16) val | [I32](builtin-I32) val | [I64](builtin-I64) val | [I128](builtin-I128) val | [ILong](builtin-ILong) val | [ISize](builtin-ISize) val)), U: [_UnsignedInteger](builtin-_UnsignedInteger)\[U\] val\]
<span class="source-link">[[Source]](src/builtin/_partial_arithmetic.md#L73)</span>


```pony
fun box neg_partial[T: (_SignedInteger[T, U] val & (I8 val | I16 val | I32 val | 
    I64 val | I128 val | ILong val | 
    ISize val)), U: _UnsignedInteger[U] val](
  x: T)
: T ?
```
#### Parameters

*   x: T

#### Returns

* T ?

---

### add_partial\[T: ([Integer](builtin-Integer)\[T\] val & ([I8](builtin-I8) val | [I16](builtin-I16) val | [I32](builtin-I32) val | [I64](builtin-I64) val | [I128](builtin-I128) val | [ILong](builtin-ILong) val | [ISize](builtin-ISize) val | [U8](builtin-U8) val | [U16](builtin-U16) val | [U32](builtin-U32) val | [U64](builtin-U64) val | [U128](builtin-U128) val | [ULong](builtin-ULong) val | [USize](builtin-USize) val))\]
<span class="source-link">[[Source]](src/builtin/_partial_arithmetic.md#L3)</span>


```pony
fun box add_partial[T: (Integer[T] val & (I8 val | I16 val | I32 val | 
    I64 val | I128 val | ILong val | 
    ISize val | U8 val | U16 val | 
    U32 val | U64 val | U128 val | 
    ULong val | USize val))](
  x: T,
  y: T)
: T ?
```
#### Parameters

*   x: T
*   y: T

#### Returns

* T ?

---

### sub_partial\[T: ([Integer](builtin-Integer)\[T\] val & ([I8](builtin-I8) val | [I16](builtin-I16) val | [I32](builtin-I32) val | [I64](builtin-I64) val | [I128](builtin-I128) val | [ILong](builtin-ILong) val | [ISize](builtin-ISize) val | [U8](builtin-U8) val | [U16](builtin-U16) val | [U32](builtin-U32) val | [U64](builtin-U64) val | [U128](builtin-U128) val | [ULong](builtin-ULong) val | [USize](builtin-USize) val))\]
<span class="source-link">[[Source]](src/builtin/_partial_arithmetic.md#L7)</span>


```pony
fun box sub_partial[T: (Integer[T] val & (I8 val | I16 val | I32 val | 
    I64 val | I128 val | ILong val | 
    ISize val | U8 val | U16 val | 
    U32 val | U64 val | U128 val | 
    ULong val | USize val))](
  x: T,
  y: T)
: T ?
```
#### Parameters

*   x: T
*   y: T

#### Returns

* T ?

---

### mul_partial\[T: ([Integer](builtin-Integer)\[T\] val & ([I8](builtin-I8) val | [I16](builtin-I16) val | [I32](builtin-I32) val | [I64](builtin-I64) val | [I128](builtin-I128) val | [ILong](builtin-ILong) val | [ISize](builtin-ISize) val | [U8](builtin-U8) val | [U16](builtin-U16) val | [U32](builtin-U32) val | [U64](builtin-U64) val | [U128](builtin-U128) val | [ULong](builtin-ULong) val | [USize](builtin-USize) val))\]
<span class="source-link">[[Source]](src/builtin/_partial_arithmetic.md#L11)</span>


```pony
fun box mul_partial[T: (Integer[T] val & (I8 val | I16 val | I32 val | 
    I64 val | I128 val | ILong val | 
    ISize val | U8 val | U16 val | 
    U32 val | U64 val | U128 val | 
    ULong val | USize val))](
  x: T,
  y: T)
: T ?
```
#### Parameters

*   x: T
*   y: T

#### Returns

* T ?

---

### eq
<span class="source-link">[[Source]](src/builtin/_partial_arithmetic.md#L46)</span>


```pony
fun box eq(
  that: _SignedPartialArithmetic val)
: Bool val
```
#### Parameters

*   that: [_SignedPartialArithmetic](builtin-_SignedPartialArithmetic) val

#### Returns

* [Bool](builtin-Bool) val

---

### ne
<span class="source-link">[[Source]](src/builtin/_partial_arithmetic.md#L46)</span>


```pony
fun box ne(
  that: _SignedPartialArithmetic val)
: Bool val
```
#### Parameters

*   that: [_SignedPartialArithmetic](builtin-_SignedPartialArithmetic) val

#### Returns

* [Bool](builtin-Bool) val

---

